import React from 'react';
import PropTypes from 'prop-types';
import { field } from '../prop-types';
import { FIELDS } from '../Standard'; // fields

import TextField from '../Standard/Fields/Text';
import NumericField from '../Standard/Fields/Numeric';
import FieldSetField from '../Standard/Fields/FieldSet';
import PickerField from '../Standard/Fields/Picker';

var ProxyField = function ProxyField(_ref) {
  var field = _ref.field,
      tabIndex = _ref.tabIndex,
      onChange = _ref.onChange,
      onBlur = _ref.onBlur,
      fieldSize = _ref.fieldSize,
      errors = _ref.errors,
      alerts = _ref.alerts;
  var Field;

  switch (field.type) {
    case FIELDS.TEXT:
      Field = TextField({
        field: field,
        tabIndex: tabIndex,
        onChange: onChange,
        onBlur: onBlur,
        errors: errors,
        alerts: alerts
      });
      break;

    case FIELDS.NUMERIC:
      Field = NumericField({
        field: field,
        tabIndex: tabIndex,
        onChange: onChange,
        onBlur: onBlur,
        errors: errors,
        alerts: alerts
      });
      break;

    case FIELDS.FIELDSET:
      Field = FieldSetField({
        field: field,
        tabIndex: tabIndex,
        onChange: onChange,
        onBlur: onBlur,
        errors: errors,
        alerts: alerts
      });
      break;

    case FIELDS.PICKER:
      Field = PickerField({
        field: field,
        tabIndex: tabIndex,
        onChange: onChange,
        onBlur: onBlur,
        errors: errors,
        alerts: alerts
      });
      break;

    default:
      Field = React.createElement("p", null, "Unknown Field type ", React.createElement("span", null, field.type));
  }

  return Field;
};

ProxyField.displayName = 'ProxyField';
export default ProxyField;